# 中文字体
原文链接：https://blog.csdn.net/weixin_44876263/article/details/145629622
详细方案
1. 删除原生字体文件
OnlyOffice的容器中可能自带一些原生的字体文件，首先需要删除这些文件，以避免与新字体发生冲突。
操作步骤：
登录到运行OnlyOffice的服务器。
使用Docker命令进入OnlyOffice容器，并删除原有的字体文件：
```
sudo docker exec $DOCKER_NAME rm -rf /var/www/onlyoffice/documentserver/core-fonts
```
这一步骤将会删除OnlyOffice编辑器中的原生字体文件。
2. 创建字体目录
在删除原有字体文件后，我们需要为新的字体文件创建一个目录，用于存放我们替换的字体。
操作步骤：
创建字体目录：
```
sudo docker exec $DOCKER_NAME mkdir /var/www/onlyoffice/documentserver/core-fonts
```
这样，我们就为新的字体文件准备好了一个存放的目录。
3. 复制字体文件到容器中
接下来，我们需要将常见的字体文件复制到容器中的指定目录。这些字体可以是任何你需要的常见字体文件，如Arial、Calibri、Times New Roman等。
![](/uploads/onlyoffice/images/m_c89d02433d6be6af8eebe49ae333b788_r.png)
操作步骤：
使用Docker命令将字体文件从宿主机复制到容器内。假设字体文件保存在 $FONTS 目录下，以下是具体命令：
```
sudo docker cp $FONTS/AlibabaPuHui.woff $DOCKER_NAME:/usr/share/fonts/truetype/custom
sudo docker cp $FONTS/Aptos.woff $DOCKER_NAME:/usr/share/fonts/truetype/custom
sudo docker cp $FONTS/Arial.woff $DOCKER_NAME:/usr/share/fonts/truetype/custom
```
在这里，$FONTS 是你存放字体文件的目录，$DOCKER_NAME 是你的OnlyOffice Docker容器的名称。每个字体文件都需要手动复制到容器内的 /usr/share/fonts/truetype/custom 目录。
4. 执行字体更新脚本
完成字体文件复制后，我们需要执行OnlyOffice的字体更新脚本，这样系统才能识别并加载新的字体。
操作步骤：
执行字体更新命令：
```
sudo docker exec $DOCKER_NAME /usr/bin/documentserver-generate-allfonts.sh
```
5. 重新启动容器
修改完字体后，需要重启OnlyOffice容器以使更改生效。
操作步骤：
使用以下命令重新启动容器：
```
sudo docker restart $DOCKER_NAME
```
重新启动容器后，新的字体配置将会生效。
![](/uploads/onlyoffice/images/m_fd596d7fa99c8c2b73fd1ee7762e6e5f_r.png)
注意事项
字体版权：使用新的字体时，请确保拥有字体文件的合法使用权。
字体格式：确保你使用的字体文件格式（如 .woff、.ttf）与OnlyOffice兼容，通常 .woff 格式是推荐的字体格式。
备份：在进行任何更改之前，最好备份现有配置文件，以防万一出现问题。

## 方案一

1. 把从 windows 字体目录拷贝的文件 cp 到镜像内

```sh
docker cp /root/fonts/ <容器ID>:/usr/share/fonts/
```
::: tip 温馨提示
拷贝之前先把中文字体属性名称改成中文,否则编辑器字体列表不会显示中文名称。

例如：【宋体】会显示成 【simsun】

<a href="../update-fonts-name/">修改中文字体名称</a>
:::

::: tip 温馨提示
如果您觉得麻烦可以下载现有的字体 <a href="../update-fonts-name/#已有中文字体">去下载</a>
:::

1.  进入容器

```sh
docker ps
docker exec -it <容器ID> /bin/bash
```

3.  执行命令

```sh
/usr/bin/documentserver-generate-allfonts.sh
```
4.  把容器保存为新镜像

```sh
docker commit -p -a "Knox" -m "fonts" <容器ID> ooffice:v1 
```

::: tip 温馨提示
如果新增字体不显示，尝试清理浏览器缓存，因为你可能读取的是浏览器缓存
:::


## 方案二

1. 用 Dockerfile 重新制作一个新的镜像
2. Dockerfile 文件示例

```sh
FROM knoxzhang/oo-ce-docker-license
COPY fonts/ /usr/share/fonts/
```

3. 制作镜像

```sh
docker build -t ooffice:v1 .
```